#include "StdAfx.h"
#include "Recognition.h"
#include "SapiException.h "

using namespace SAPI;
using namespace System::Diagnostics;


// t@CiCU
Recognition::!Recognition()
{
    delete m_sapi;
}

// 
bool Recognition::Init( System::IntPtr hWnd )
{
    return Init( hWnd, nullptr );
}

// 
bool Recognition::Init( System::IntPtr hWnd, System::String^ grammarFile )
{
    Debug::WriteLine( "SAPI" );

    // SAPI\z
    m_sapi = new SpeechEngine();

    // EBhE nhփLXg
    HWND windowHandle = reinterpret_cast< HWND >( hWnd.ToInt32() );

    try
    {
        pin_ptr< wchar_t > wcharPinptr = nullptr;

        if( grammarFile != nullptr )
        {
            // System::Stringwchar_t^̔zɂ
            array< wchar_t >^ wcharArray = grammarFile->ToCharArray();

            // ... A}l[W֐ɓn߂ɁAz̃AhXŒ肷
            wcharPinptr = &wcharArray[ 0 ];
        }

        // 
        m_sapi->Init( windowHandle, wcharPinptr );
    }
    catch( SapiException* e )
    {
        // SAPI̗Oߑ
        Debug::WriteLine( gcnew System::String( e->GetMessage() ) );
        Debug::WriteLine( "SAPȈɎs" );

        return false;
    }

    return true;
}

// FCxg擾
int Recognition::GetRecognitionEvent()
{
    return m_sapi->GetRecognitionEvent();
}

// Fʂ擾
bool Recognition::GetRecognitionResult( System::String^% text )
{
    wchar_t result[ WORD_MAX_SIZE ];

    if( !m_sapi->GetRecognitionResult( result ) )
    {
        return false;
    }

    // ^ϊ
    text = gcnew System::String( result );

    return true;
}

// Fꂽ擾
bool Recognition::GetRecognizedPronunciation( System::String^% text )
{
    wchar_t result[ WORD_MAX_SIZE ];

    if( !m_sapi->GetRecognizedPronunciation( result ) )
    {
        return false;
    }

    // ^ϊ
    text = gcnew System::String( result );

    return true;
}

// Mx擾
bool Recognition::GetConfidence( double& value )
{
    if( !m_sapi->GetConfidence( value ) )
    {
        return false;
    }

    return true;
}


// Ԃ擾
System::String^ Recognition::GetState( int eventID )
{
    return gcnew System::String( m_sapi->GetState( eventID ) );
}